package task04;

import java.io.File;
import java.lang.reflect.Method;
import java.net.URL;
import java.security.CodeSource;
import java.util.HashMap;
import java.util.Map;

/**
 * Enhanced implementation of ThrowableRenderer. Uses Throwable.getStackTrace if
 * running on JDK 1.4 or later and delegates to DefaultThrowableRenderer.render
 * on earlier virtual machines.
 * 
 * @since 1.2.16
 */
@SuppressWarnings("unused")
public final class Task04 {
	/**
	 * Throwable.getStackTrace() method.
	 */
	private Method getStackTraceMethod = null;
	/**
	 * StackTraceElement.getClassName() method.
	 */
	private Method getClassNameMethod = null;

	/**
	 * TODO #04 (Log4j)
	 * <p>
	 * Construct new instance.
	 */
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public Task04(){
		try {
			Class[] noArgs = new Class[] {};
			getStackTraceMethod = Throwable.class.getMethod("getStackTrace",
					noArgs);
			Class ste = Class.forName("java.lang.StackTraceElement");
			getClassNameMethod = ste.getMethod("getClassName", noArgs);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public Method getGetStackTraceMethod() {
		return getStackTraceMethod;
	}

	public Method getGetClassNameMethod() {
		return getClassNameMethod;
	}

}