package task10;

import java.io.IOException;
import java.security.SignatureException;

public class Task10 {
	PdfReader reader = new PdfReader();

	/**
	 * TODO #10 (iText)
	 */
	public void updateByteRange(PdfPKCS7 pkcs7, PdfDictionary v) {
		PdfArray b = v.getAsArray(PdfName.BYTERANGE);
		RandomAccessFileOrArray rf = reader.getSafeFile();
		try {
			rf.reOpen();
			byte buf[] = new byte[8192];
			for (int k = 0; k < b.size(); ++k) {
				int start = b.getAsNumber(k).intValue();
				int length = b.getAsNumber(++k).intValue();
				rf.seek(start);
				while (length > 0) {
					int rd = rf.read(buf, 0, Math.min(length, buf.length));
					if (rd <= 0)
						break;
					length -= rd;
					pkcs7.update(buf, 0, rd);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if (rf != null) {
					rf.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
}
