package task13;

import java.io.IOException;
import java.net.URL;

import org.xml.sax.SAXNotRecognizedException;
import org.xml.sax.SAXNotSupportedException;

/**
 * <p>
 * SAX parser implementation that uses the NekoHTML
 * {@link org.cyberneko.html.HTMLConfiguration} to parse HTML into a
 * HtmlUnit-specific DOM (HU-DOM) tree.
 * </p>
 */
public class Task13 {

	/**
	 * TODO #13 (htmlunit)
	 */
	public static void parse(final WebResponse webResponse,
			final WebWindow webWindow, final HtmlPage page, final boolean xhtml) throws SAXNotSupportedException, SAXNotRecognizedException {
		webWindow.setEnclosedPage(page);
		final URL url = webResponse.getWebRequest().getUrl();
		final HtmlUnitDOMBuilder domBuilder = new HtmlUnitDOMBuilder(page, url);

		String charset = webResponse.getContentCharsetOrNull();
		try {
			// handle charset
			if (charset != null) {
				domBuilder.setFeature(HTMLScanner.IGNORE_SPECIFIED_CHARSET,
						true);
			} else {
				final String specifiedCharset = webResponse.getWebRequest()
						.getCharset();
				if (specifiedCharset != null) {
					charset = specifiedCharset;
				}
			}

			// xml content is different
			if (xhtml) {
				domBuilder.setFeature(HTMLScanner.ALLOW_SELFCLOSING_TAGS, true);
			}
		} catch (NullPointerException e) {
			e.printStackTrace();
		}
		System.out.println(charset);
	}
}
