package task16;

import java.io.IOException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.KeyManagementException;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;

public class Task16 {

	/**
	 * TODO #16 (htmlunit)
	 * <p>
	 * Returns the SSLSocketFactory to use.
	 * 
	 * @return the SSLSocketFactory
	 */
	static SSLSocketFactory getSSLSocketFactory(final WebClient webClient) {
		if (webClient.getSSLClientCertificateUrl() == null) {
			return SSLSocketFactory.getSocketFactory();
		}
		try {
			final KeyStore keyStore = KeyStore.getInstance(webClient
					.getSSLClientCertificateType());
			final String password = webClient.getSSLClientCertificatePassword();
			final char[] passwordChars = password != null ? password
					.toCharArray() : null;
			keyStore.load(webClient.getSSLClientCertificateUrl().openStream(),
					passwordChars);
			return new SSLSocketFactory(keyStore, password);
		} catch (Exception e) { 
			e.printStackTrace();
		}

		return null;
	}

}
